// --------------------------------------------------------------
// Modify below variables based on your widget ID
// --------------------------------------------------------------
var comboBox_widget_ID = "boxFilterRecipes";
var field_widget_ID = "txtRecipeFilter";


// --------------------------------------------------------------
// Apply the filter using the typed text
// --------------------------------------------------------------
function txtRecipeFilter_onDataUpdate(me, eventInfo)
{
    updateComboBox();
}


// --------------------------------------------------------------
// Update the selected set into recipe manager
// --------------------------------------------------------------
function boxFilterRecipes_onDataUpdate(me, eventInfo)
{
    updateSelectedSetIndex();
}


// --------------------------------------------------------------
// DO NOT CHANGE BELOW THIS LINE
// --------------------------------------------------------------
var recipeManagerSetList = project.getWidget("_RecipeMgr").getProperty("curRecipeSetList");
var recipeManagerArrayOfSets = recipeManagerSetList.split(",");
var txt = page.getWidget(field_widget_ID);
var combo = page.getWidget(comboBox_widget_ID);


// --------------------------------------------------------------
// This function loop into recipe manager all the available sets
// matching the value typed in field widget, then populate the ComboBox widget
// This function is called:
//                        - OnDataUpdate of field widget
//                        - OnActivate of page
// --------------------------------------------------------------
function updateComboBox()
{  
    var filter = txt.getProperty("value");        
    if (filter) {
        // Something is typed into field widget
        // we have to filter ComboBox
        
        var set;
        var newArrayOfSets = [];

        // Parse curRecipeSetList array called recipeManagerArrayOfSets
        // and copying sets matching the applied filter into newArrayOfSets
        for (i=0; i<recipeManagerArrayOfSets.length; i++){
            set = recipeManagerArrayOfSets[i];
            if (filter === "")
				newArrayOfSets.push(set);
            else if (set.search(filter) !== -1) 
				newArrayOfSets.push(set);
        }
        
        // Updating ComboBox list values with newArrayOfSets 
        var newRecipeSetList = newArrayOfSets.join(",");
        combo.setProperty("list", newRecipeSetList); 
		
        // Reset the selected index into ComboBox
        if (newArrayOfSets.length > 0) {
            combo.setProperty("index", 0);
        } else {   
            combo.setProperty("index", -1);    
        }
    } else {
        // No filter is applied so populate ComboBox with defalt values
        combo.setProperty("list", recipeManagerSetList);
        combo.setProperty("index", 0);
    }
    
    updateSelectedSetIndex();
}


// --------------------------------------------------------------
// This function read the selected set into ComboBox widget
// and update the CurrentSelectedSet into Recipe Manager accordingly
// This function is called:
//                        - by function updateComboBox()
//                        - OnDataUpdate of comboBox
// --------------------------------------------------------------
function updateSelectedSetIndex(){
  
    var comboWidget = page.getWidget(comboBox_widget_ID);
    var comboArrayList = comboWidget.getProperty("list").split(",");
    var comboIndex = combo.getProperty("index");
    var comboSelectedSet = comboArrayList[comboIndex];
	
    // looping to find the set selected into ComboBox into Recipe Manager
    var set;
    var index = 0;
    for (i=0; i<recipeManagerArrayOfSets.length; i++)
    {
        set = recipeManagerArrayOfSets[i];
        if (set.search(comboSelectedSet)!== -1)
        {
            index = i;
            break;
        }
    }    
    // setting the currentSelectedSet into Recipe Manager
    project.getWidget("_RecipeMgr").setProperty("CurrentRecipe.CurrentSelectedSet.Value", index);
}